#!/usr/bin/python
import pdb
import matplotlib
matplotlib.use('GTKAgg')

import pylab as pl
from pylab import cm

# switch comments for gtk over gtkagg
#from matplotlib.backends.backend_gtk import FigureCanvasGTK as FigureCanvas
from matplotlib.backends.backend_gtkagg import FigureCanvasGTKAgg as FigureCanvas

#currently backend_gtk DOESN'T have NavigationToolbar functionallity, need to get this fixed
# or NavigationToolbar for classic
#from matplotlib.backends.backend_gtk import NavigationToolbar2GTKAgg as NavigationToolbar

from matplotlib.axes import Subplot
from matplotlib.figure import Figure

from matplotlib.mlab import meshgrid
from matplotlib.mlab import bivariate_normal
from matplotlib import rcParams

import pygtk
## pygtk.require('2.0')
import gtk

from gauss_mpfit2 import gauss_fit
from mapping import *
import numarray as na
import numarray.mlab as mlab
import controlMountSocket
import common
#import mircMapping
#import mircMappingXchan
#import IRCamSocket
#import IRCamCommands
import time
import os.path

class fiber:		
    #move luminos function
#    def move(self,widget,direction):
#        xy = long(self.lumi_spin_button[0].get_value())
#        zz = long(self.lumi_spin_button[1].get_value())
#        dct = {'UP':[3, 250*xy], 'DOWN':[3, -250*xy], 'RIGHT':[2, 250*xy],\
#               'LEFT':[2,-250*xy], 'IN':[1, 10*zz],'OUT':[1, -10*zz]}
#        try: self.lum.move_relative(self.lum_stage, dct[direction][0], dct[direction][1])
#        except: print 'function move received direction = ',direction

#        if (self.auto_det_section):
#            self.view_detector_section(0)

#        if (self.detector_configured):
#            self.getFrame()
#            print 'intensity: ', self.mm.get_intensity(self.ij_range)
		
        #refresh positions
#        self.refresh_positions(0)
			
    #function to automatically display detector section after each move (toggle switch)
#    def auto_det_section_toggled(self,widget):
#        self.auto_det_section = self.auto_det_section_check.get_active()

    #function for changing active luminos mount, menus in both the luminos and mapping tabs are changed
#    def luminos_menu_changed(self,combo_box):
#        self.lum_stage = combo_box.get_active() + 1
#        self.luminos_combo_box.set_active(self.lum_stage - 1)
		
        #insert function to refresh positions listed
#        self.refresh_positions(0)
			
    #function for returning an arrow button
    def create_arrow_button(self,arrow_type, shadow_type):
        button = gtk.Button();
        arrow = gtk.Arrow(arrow_type, shadow_type);
        button.add(arrow)
        button.show()
        arrow.show()
        return button	
	
    #functions for saving current position to a file
    def save_pos(self,widget):		
        self.save_filew = gtk.FileSelection('Save all positions to file')
        self.save_filew.connect("destroy",lambda w: self.save_filew.destroy())
        self.save_filew.ok_button.connect("clicked",self.file_save_action)
        self.save_filew.cancel_button.connect("clicked",lambda w: self.save_filew.destroy())
        self.save_filew.show()

    #function to actually do the filesaving
#    def file_save_action(self,widget):
#        self.lum.save_position(self.save_filew.get_filename(),self.nluminos)
#        print "save info to %s" % self.save_filew.get_filename()
#        self.save_filew.destroy()

    #functions for recalling position from a file
    def recall_pos(self,widget):	
        self.recall_filew = gtk.FileSelection('Recall all positions from file')
        self.recall_filew.connect("destroy",lambda w: self.recall_filew.destroy())
        self.recall_filew.ok_button.connect("clicked",self.file_recall_action)
        self.recall_filew.cancel_button.connect("clicked",lambda w: self.recall_filew.destroy())
        self.recall_filew.show()

#    def recall_last_posi(self,widget):
        #pdb.set_trace()
#        self.lum.recall_position(self.lum_stage_file,self.num_stages)
#        print "recalled info from %s" % self.lum_stage_file
#        self.refresh_positions(0)
        

    #function that actually recalls the file
    def file_recall_action(self,widget):
#        self.lum.recall_position(self.recall_filew.get_filename(),self.nluminos)
        print "recalled info from %s" % self.recall_filew.get_filename()
        self.recall_filew.destroy()		
        
        #insert function to refresh position
        self.refresh_positions(0)

    #move to what's entered in the position text boxes
#    def move_to_enterred(self,widget):
#        print 'moving mount ',self.lum_stage, ' to X:, ',long(self.lumi_position_entry[0].get_text()),\
 #             ' Y:,',long(self.lumi_position_entry[1].get_text()),' Z:,',\
 #             long(self.lumi_position_entry[2].get_text())
#        self.lum.move_absolute(self.lum_stage,2,long(self.lumi_position_entry[0].get_text()))
#        self.lum.move_absolute(self.lum_stage,3,long(self.lumi_position_entry[1].get_text()))
#        self.lum.move_absolute(self.lum_stage,1,long(self.lumi_position_entry[2].get_text()))
		
#        if (self.auto_det_section):
#            self.view_detector_section(0)
		
#        self.refresh_positions(0)


    #reload positions		
    def refresh_positions(self,widget):
        self.xposition += 1
        self.yposition += 1
        self.zposition += 1
        
        #text in the Luminos Tab
#        page=self.notebook.get_current_page()
#        if page == 0:
#            self.lum_stage=self.luminos_combo_box.get_active()+1
#            self.lumi_position_entry[0].set_text(str(self.lum.absolute_position(self.lum_stage,2)))
#            self.lumi_position_entry[1].set_text(str(self.lum.absolute_position(self.lum_stage,3)))
#            self.lumi_position_entry[2].set_text(str(self.lum.absolute_position(self.lum_stage,1)))
		
        #text in the mapping tab (z position in microns)
#        if page ==1:
#            self.stage_z_position_output.set_text(str(self.lum.absolute_position(self.z_pos_active_stage,1) / 10.))

#    def index_to_enterred(self,widget):
#        self.lum.set_position(self.lum_stage,1,long(self.lumi_position_entry[2].get_text()))
#        self.lum.set_position(self.lum_stage,2,long(self.lumi_position_entry[0].get_text()))
#        self.lum.set_position(self.lum_stage,3,long(self.lumi_position_entry[1].get_text()))
#        print 'indexing mount ',self.lum_stage, ' to X:, ',self.lumi_position_entry[0].get_text(),\
#              ' Y:,',self.lumi_position_entry[1].get_text(),' Z:,',self.lumi_position_entry[2].get_text()
		
#    def renumber_mount(self,widget):
#        print "self.nluminos = ", self.nluminos
        
#        for i in range(self.nluminos):
#            self.luminos_combo_box.remove_text(0)

#        print 'renumbering mounts '
#        self.nluminos = self.lum.renumber()	
		
#        for i in range(self.nluminos):
#            self.luminos_combo_box.append_text('Luminos Stage # %d' % (i+1))
		
#        self.luminos_combo_box.set_active(0)

#    def restart_mounts(self,widget):
#        self.lum.restart()
#        self.renumber_mount(0)		

    def home_dialog(self,stages,index):
        self.dialog=gtk.Dialog(title='Home stages dialog')
        OK_button=gtk.Button('OK')
        self.dialog.action_area.pack_start(OK_button,True,True)
        OK_button.show()
        OK_button.connect('clicked',self.home_stages,stages,index)
        Cancel_button=gtk.Button('Cancel')
        self.dialog.action_area.pack_start(Cancel_button,True,True)
        Cancel_button.show()
        Cancel_button.connect('clicked',self.dialog_destroy)
        Label=gtk.Label('\
        Warning: this action may cause the\n \
        reference positions of some stages\n \
        to drift due to the failure of home\n\
        trigger. Do NOT home fiber stages\n\
        unless there was a power outage.\n\
        ')
        self.dialog.vbox.pack_start(Label,True,True)
        Label.show()
        self.dialog.show() 
        
    def home_all_mount(self,widget):
        self.home_dialog(0,False)
    
    
    def home_mount(self,widget):
        self.home_dialog(self.lum_stage,False)

    def home_mount_index(self,widget):
        self.home_dialog(self.lum_stage,True)

    def home_all_index(self,widget):
        self.home_dialog(0,True)
        

    def home_stages(self,widget,stages,index_as_0):
        #pdb.set_trace()
#        self.lum.home(stages,0,index_as_0)
        self.dialog.destroy()
        self.refresh_positions(0)
        

    def dialog_destroy(self,widget):
        self.dialog.destroy()

   

			
    def active_stages(self):
        active_stages=na.zeros(self.num_stages)
        for ii in range(self.num_stages):
            if (self.stage_check_button[ii].get_active()):
                self.all_stage[ii].active=1
                active_stages[ii]=1
            else:
                self.all_stage[ii].active=0
                
        return active_stages

    def z_pos_rbutton_callback(self,widge,data):
        self.z_pos_active_stage=data
        self.refresh_positions(0)

    def move_z_pos(self,widge,data):
        steps=self.z_position_spin_button.get_value_as_int()*10
#        if data=='INC':
#            self.lum.move_relative(self.z_pos_active_stage, 1, steps)
#        else:
#            self.lum.move_relative(self.z_pos_active_stage, 1, -steps)
        self.refresh_positions(0)


    def z_spin_button_changed(self,widget):
        self.z_map_spin_button.set_value(self.lumi_spin_button[1].get_value())

## JDM removal
##    def move_to_max_toggled(self,widget):
##        self.move_to_max = self.mapping_settings_check[0].get_active()
##        print 'self.move_to_max = ',self.move_to_max
##        if (self.move_to_max):
##            self.mapping_settings_check[1].set_active(False)	
	
##    def move_to_gauss_peak_toggled(self,widget):
##        self.move_to_gauss_peak = self.mapping_settings_check[1].get_active()
##        print 'self.move_to_gauss_peak = ',self.move_to_gauss_peak
##        if (self.move_to_gauss_peak):
##            self.mapping_settings_check[0].set_active(False)

#    def display_as_mapped_toggled(self,widget):
#        self.display_as_mapped = self.mapping_settings_check[0].get_active()
## JDM index above was 2.

##    def show_surface_after_toggled(self,widget):
##        self.show_surface_after = self.mapping_settings_check[3].get_active()

#    def show_image_after_toggled(self,widget):
#        self.show_image_after = self.mapping_settings_check[1].get_active()

    def move_to_max(self,widget):
        active_stages=self.active_stages()
        for ii in range(self.num_stages):
            if self.all_stage[ii].active==0:continue
            if self.last_map_params[ii][5] == 1:
                print 'please do a map first for ',self.all_stage[ii].name
                continue
            else:
#                self.lum.move_absolute(self.all_stage[ii].stage,2,long(self.all_stage[ii].last_max[0]))
#                self.lum.move_absolute(self.all_stage[ii].stage,3,long(self.all_stage[ii].last_max[1]))
#                self.lum.move_absolute(self.all_stage[ii].stage,1,long(self.all_stage[ii].last_max[2]))
                self.refresh_positions(0)
## JDM 2007 Jul26  SAVE positions for kludgy communcations with IRCam
##  this filename is defined in common.py
#        self.lum.save_position(common.luminos_currents,self.nluminos)
        print "saving current positions in ~observe/mirc_python/.current_luminos_positions"


    def show_last_surface(self,widget):
        if (self.map_error):
            print 'please take a map first'
            return
        
        print 'scipy not yet intalled!'
 		
    def show_last_image(self,widget):
        self.plot_image(gauss=False)
        
    def move_to_gauss_peak(self,widget):
        active_stages=self.active_stages()
        for ii in range(self.num_stages):
            if self.all_stage[ii].active==0:continue
            if self.last_map_params[ii][5] == 1:
                print 'please do a map first',self.all_stage[ii].name
                continue
#            self.lum.move_absolute(self.all_stage[ii].stage,2,long(self.all_stage[ii].last_gauss[0]))
#            self.lum.move_absolute(self.all_stage[ii].stage,3,long(self.all_stage[ii].last_gauss[1]))
#            self.lum.move_absolute(self.all_stage[ii].stage,1,long(self.all_stage[ii].last_max[2]))
            self.refresh_positions(0)

## JDM 2007 Jul26  SAVE positions for kludgy communcations with IRCam
##   defined in common.py
#   	self.lum.save_position(common.luminos_currents,self.nluminos) 
 	print "saving current positions in ~/observe/mirc_python/.current_luminos_positions"

    def show_last_gauss(self,widget):
        if self.last_map_params[0] == 0:
            print 'please do a map first'
        else:
            self.plot_image()

## 	def img_changed(self,widget,letter):
## 		if letter == 'a':
## 			self.range_i[0]=self.a_spin_button.get_value_as_int()
## 		elif letter == 'b':
## 			self.range_i[1]=self.b_spin_button.get_value_as_int()
## 		elif letter == 'c':
## 			self.range_j[0]=self.c_spin_button.get_value_as_int()
## 		elif letter == 'd':
## 			self.range_j[1]=self.d_spin_button.get_value_as_int()
    def img_changed(self,widget,letter):
##         tokenDict = {'a': self.spin_button[0].get_value_as_int,
##                      'b': self.spin_button[1].get_value_as_int,
##                      'c': self.spin_button[2].get_value_as_int,
##                      'd':self.spin_button[3].get_value_as_int}
        tokenDict1 = {'a': 0,'b': 1,'c': 2,'d':3}
        tokenDict2 = {'a': 2,'b': 3,'c': 0,'d':1}
        
        self.ij_range[tokenDict2[letter]] = self.spin_button[tokenDict1[letter]].get_value_as_int()
        print letter, tokenDict2[letter], self.ij_range[tokenDict2[letter]]

    def view_detector_section(self,widget):
        if (self.detector_configured):
            #JDM makes everything a loop...	
            for i in range(self.do_loop_spin_button.get_value_as_int()):
                self.plot_exposure(section=True)
        else:
            print 'please configure detector'
			
    def view_whole_detector(self,widget):
        if (self.detector_configured):
            for i in range(self.do_loop_spin_button.get_value_as_int()):
                self.plot_exposure(section=False)
        else:
            print 'please configure detector'

    def save_image(self,widget):
        if (self.detector_configured):
            print 'set do_save_image to one, take exposure, then set it back to 0'
            self.ircc.doImageSave = 1
            self.ircc.updateDoImageSave()
            self.ircc.startExposure()
            self.ircc.doImageSave = 0
            self.ircc.updateDoImageSave()
        else:
            print 'please configure detector'

    def view_cross_section(self,widget):
        rcParams['interactive']=True        
        if (self.detector_configured):
            fig_cross = pl.figure(3)
            fig_cross.clf()
            a = fig_cross.add_subplot(111)
            canvas = FigureCanvas(fig_cross)
            canvas.queue_draw()
            for i in range(self.do_loop_spin_button.get_value_as_int()):
                self.getFrame()
                pl.xlabel('Cross sectrion across img[:][%s]' %self.e_spin_button.get_value_as_int())
                if i == 0:
                    self.lines, = pl.plot(common.dataArray[self.e_spin_button.get_value_as_int(), :], linewidth=1)
                else:
                    self.lines.set_ydata(common.dataArray[self.e_spin_button.get_value_as_int(), :])
                a.dataLim.update_numerix(self.lines.get_xdata(),self.lines.get_ydata(),True)
                a.autoscale_view()
                canvas.draw()
        else:
            print 'please configure detector'

    def run_do_loop(self,widget):
        if (self.detector_configured):
            for i in range(nloops):
                self.ircc.numberOfFrames = self.exp_time_spin_button.get_value_as_int()*nloops
                self.ircc.numberOfCoadds = self.ircc.numberOfFrames
                print 'sendStruct()'
                self.ircc.sendStruct()
                print 'resetCont()'
                self.ircc.resetCont()
                print 'setCont()'
                self.ircc.setCont()
                print'setBias()'
                self.ircc.setBias()
                self.getFrame()
                
                pl.plot(common.dataArray[:,row])

            print 'run do_loop across img[:][',self.e_spin_button.get_value_as_int(),'] for ',\
                  self.do_loop_spin_button.get_value(),' iterations'
        else:
            print 'please configure detector'

    def start_exposure(self, widget):
        if widget.get_label() == 'Start exposure':
            widget.set_label('Stop exposure')
            print "self.ircc.continuousReadout =", self.ircc.continuousReadout
            if not self.ircc.continuousReadout: self.ircc.continuousReadout = 1
            self.ircc.sendStruct()
            #added a sleep between the two commands
            #without sleep startExp fails
            time.sleep(1)
            self.ircc.startExposure()
        else:
            widget.set_label('Start exposure')
            self.ircc.stopExposure()


    def take_background(self, widget):
        self.ircc.getBackgroundFrame()
    
    def reset_background(self, action):
        self.ircc.resetBackgroundFrame()

    def use_background(self, widget):
        self.ircc.useBackgroundFrame()

#    def set_xchan_position(self):
#        posi=[]
#        for ii in range(self.num_stages):
#            posi.append(int(self.xchan_position_entry[ii].get_text()))
#        print posi
#        self.mm.xchan_positions(posi)

#    def change_number_of_frames(self,widget):
##         self.ircc.numberOfFrames = self.exp_time_spin_button.get_value_as_int()
##         self.ircc.numberOfCoadds = self.ircc.numberOfFrames
#        common.numberOfCumulatedImages = self.exp_time_spin_button.get_value_as_int()
##         print 'number of frames/coadds is set to:', self.ircc.numberOfFrames
        
    def configure_detector(self,widget):
        if self.first_time_configured:
            print 'first configure'
            self.first_time_configured = 0
        self.ircc.rows = 256
        self.ircc.cols = 254
        self.ircc.rowOffset = 0
        self.ircc.colOffset = 1
        self.ircc.nreads = 4
        self.ircc.numberOfCoadds = 10
        self.ircc.framesPerReset = 11
        self.ircc.expTime = 0
        self.ircc.numberOfFrames = 11
        self.ircc.byteSwapping  =False
        self.ircc.doReset = True
        self.ircc.doDeinterlace = False
        self.ircc.doImageSave = False
        self.ircc.daqRunning = False
        self.ircc.read = False
        self.ircc.voffset = 4.0
        self.ircc.vreset = 0.6
        self.ircc.vd = 5.0
        self.ircc.ictl = 3.3
        self.ircc.continuousReadout = 1
        
        self.ircc.imageDirectory = '/data/'
        self.ircc.imageFilename = 'fiberExplorer.fit'
        
        self.ircc.useBackground = False
        self.ircc.numberOfBackgroundFrames = 1000

        common.rows = self.ircc.rows
        common.cols = self.ircc.cols
        common.rowOffset = self.ircc.rowOffset
        common.colOffset = self.ircc.colOffset

        print 'sendStruct()'
        self.ircc.sendStruct()
        time.sleep(.5)
        print 'resetCont()'
        self.ircc.resetCont()
        time.sleep(.5)
        print 'setCont()'
        self.ircc.setCont()
        time.sleep(.5)
        print'setBias()'
        self.ircc.setBias()		
        time.sleep(.5)
		
##         self.dat.do_image_show = 0
##         self.dat.do_image_save = 0
##         self.g = Graphics()
        
        self.detector_extent = (-0.5,255.5,-0.5, 255.5)
        common.dataArray = na.zeros((self.ircc.rows, self.ircc.cols), type=na.Float32)
        self.detector_extent = (-0.5,self.ircc.cols+0.5,-0.5, self.ircc.rows+0.5)
        self.detector_configured = 1

    def load_detector_config(self,widget):
        print 'getStruct()'
        self.ircc.getStruct()
        
        self.ircc.imageFilename = 'fiberExplorer.fit'
        self.ij_range[0] = 0
        self.ij_range[1] = self.ircc.rows
        self.ij_range[2] = 0
        self.ij_range[3] = self.ircc.cols

        self.spin_button[2].set_value(0)
        self.spin_button[3].set_value(self.ircc.rows)
        self.spin_button[0].set_value(0)
        self.spin_button[1].set_value(self.ircc.cols)

        self.detector_extent = (-0.5,self.ircc.cols-0.5,-0.5,self.ircc.rows-0.5)
        print self.ircc.cols, self.ircc.rows
        common.dataArray = na.zeros((self.ircc.rows, self.ircc.cols), type=na.Float32)
        self.detector_configured = 1
        
    def kill_server(self,widget):
        self.ircc.killServer()
        self.detector_configured = 0

    def plot_image(self,gauss=True):

        if (self.map_error):
            print 'please take a map first'
            return
		
        rcParams['interactive']=True
	
	for ii in range(self.num_stages):
            if self.all_stage[ii].active==0:continue
            delta = self.all_stage[ii].xarray[1]-self.all_stage[ii].xarray[0]
            xmin = self.all_stage[ii].xarray[0]-delta/2.
            xmax = self.all_stage[ii].xarray[-1]+delta/2.
            ymin = self.all_stage[ii].yarray[0]-delta/2.
            ymax = self.all_stage[ii].yarray[-1]+delta/2.   # replaced -delta/2 by +delta/2 
            self.extent = (xmin,xmax,ymin,ymax)
        
            pl.figure(10+ii)
            pl.clf()		

            pl.imshow(self.all_stage[ii].intensity,cmap=cm.hot,extent=self.extent,origin='lower',\
                      vmin =self.all_stage[ii].intensity.min(),\
                      vmax =self.all_stage[ii].intensity.max(),interpolation='nearest',aspect='auto')
            if (gauss):
                pl.contour(self.all_stage[ii].intensity_fit,cmap=cm.bone,extent=self.extent,origin='lower')
                title = 'Intensity vs Position Image w/ Gauss Contour, nMaps = %d ' %self.nMaps+self.all_stage[ii].name
                pl.title(title)
            else:
                title = 'Intensity vs Position Image, nMaps = %d ' %self.nMaps+self.all_stage[ii].name
                pl.title(title)

            if self.first_time_plot:
                pl.xlabel('X Position in Steps')
                pl.ylabel('Y Position in Steps')
                pl.ylabel('Y Position in Steps') #advance the frame
		
    def plot_exposure(self,section=False):
        self.getFrame()
        rcParams['interactive']=True
        
        pl.figure(1)
        if (section):
            self.detector_extent = (self.ij_range[2]-0.5,self.ij_range[3]-0.5,\
                                    self.ij_range[0]-0.5,self.ij_range[1]-0.5)
##             self.reduced_exposure = na.transpose(na.transpose(common.dataArray[self.ij_range[0]:self.ij_range[1]+1].copy())[self.ij_range[2]:self.ij_range[3]+1].copy())
            self.reduced_exposure = common.dataArray[self.ij_range[0]:self.ij_range[1]+1,self.ij_range[2]:self.ij_range[3]+1].copy()
            kludgemedian=mlab.median(mlab.median(1.0*self.reduced_exposure))
            tempvar=na.transpose(1.0*self.reduced_exposure-kludgemedian)
            kludgesum = tempvar.sum()
            tempvar=tempvar/kludgesum
            print 'Median of Section: ', kludgemedian
            print 'flux fraction map: '
            # print fix(tempvar*100.0)
            # print (tempvar*100.0).astype("Int32")
            pl.imshow((self.reduced_exposure),interpolation='nearest', \
                cmap=cm.gray,extent=self.detector_extent,origin='lower',aspect='auto')
            pl.title('Section Exposure w/ max: %e and min %e' % (self.reduced_exposure.max(),\
                                                              self.reduced_exposure.min()))
        else:
            self.detector_extent = (-0.5,self.ircc.cols-0.5,-0.5,self.ircc.rows-0.5)
            pl.imshow(common.dataArray,cmap=cm.gray,extent=self.detector_extent, origin='lower',\
                      interpolation='nearest',aspect='auto') 	
            pl.title('Exposure w/ max: %e and min %e' % (common.dataArray.max(), common.dataArray.min()))
            

        if self.first_time_exposure:
            pl.xlabel('dat.img[x][]')
            pl.ylabel('dat.img[][y]')
            pl.ylabel('dat.img[][y]') # to advance the frame
            self.first_time_exposure = 0

    def getFrame(self):
        #variable that is use to check if the available frame is a new frame
        coadd = common.coaddCount
        cnt = 0
        #img = na.zeros((common.numberOfCumulatedImages, common.rows, common.cols), type = na.Float32)
##         tmp = na.zeros((common.rows, common.cols), type = na.Float32)
        tmp = na.zeros((self.ircc.rows, self.ircc.cols), type = na.Float32)
        for i in range(common.numberOfCumulatedImages):
            while coadd == common.coaddCount:
                coadd = self.ircc.coaddCount()
                cnt += 1
                time.sleep(.2)
                # a new frame is available, read the new frame
            self.ircs.readFrame()
            common.coaddCount = coadd
            tmp += common.dataArray
            #img[i, :, :] = common.dataArray
        common.dataArray = tmp/common.numberOfCumulatedImages

    def getFrameOld(self):
        #variable that is use to check if the available frame is a new frame
        coadd = common.coaddCount
        cnt = 0
        while coadd == common.coaddCount:
            coadd = self.ircc.coaddCount()
            cnt += 1
            time.sleep(.2)
        # a new frame is available, read the new frame
        self.ircs.readFrame()
        common.coaddCount = coadd
		
    def getNextFrame(self):
        #variable that is use to check if the available frame is a new frame
        common.coaddCount = self.ircc.coaddCount()
        coadd = common.coaddCount
        cnt = 0
        while coadd < common.coaddCount+2:
            coadd = self.ircc.coaddCount()
            cnt += 1
            time.sleep(.2)
        # a new frame is available, read the new frame
        self.ircs.readFrame()
        common.coaddCount = coadd
        if common.numberOfCumulatedImages>1:
            cnt = 0
            tmp = common.dataArray
            for i in range(common.numberOfCumulatedImages-1):
                while coadd == common.coaddCount:
                    coadd = self.ircc.coaddCount()
                    cnt += 1
                    time.sleep(.2)
                    # a new frame is available, read the new frame
                self.ircs.readFrame()
                common.coaddCount = coadd
                tmp += common.dataArray
            common.dataArray = tmp/common.numberOfCumulatedImages
            
    def getNextFrameOld(self):
        #variable that is use to check if the available frame is a new frame
        common.coaddCount = self.ircc.coaddCount()
        coadd = common.coaddCount
        cnt = 0
        while coadd != common.coaddCount+1:
            coadd = self.ircc.coaddCount()
            cnt += 1
            time.sleep(.2)
        # a new frame is available, read the new frame
        self.ircs.readFrame()
        common.coaddCount = coadd

    def destroy(self, widget):
        gtk.main_quit()
#        x=time.localtime()
#        filename=str(x[0])+'_'+str(x[1])+'_'+str(x[2])+'.lum'
#        self.lum.save_position(self.path+self.lum_dir+'/'+filename,self.nluminos)
#        self.lum.save_position(self.path+self.lum_dir+'/'+self.lum_stage_file,self.nluminos)
#        print "save info to %s and %s" % (filename,self.lum_stage_file)
		
    def __init__(self, test = None):

#        self.mm = mircMapping.mircMapping()
#        self.mm=mircMappingXchan.mircMapping()
#        self.ircs = IRCamSocket.IRCamSocket()
#        self.ircc = IRCamCommands.IRCamCommands()
        
#        self.first_time_configured = 1
#        self.first_time_exposure = 1
#        self.first_time_plot = 1
#        self.display_as_mapped=1
#        self.stages = [1,2,3,4]       #change to [1,2,3,4,5,6] for 6 beams
#        self.num_stages=4              #change to 6 for 6 beams
#        self.z_pos_active_stage=1        #in mapping tab, the active z position radio button
#        self.lum_stage=1               #in luminos tab, the active stage #
#        self.lum_stage_file=common.luminos_currents[1]
#        self.lum_stage_file='stage_positions.lum'
#        self.path=os.path.abspath('')
#        self.lum_dir='/lum_stage_positions'
#        self.xchan_pos=[111,130,136,99]


        #pass self.num_stages to mircMappingXchan
#        self.mm.stages_number(self.num_stages)

## initialises the serial connections with the luminos and zaber stages


## FIRST DO LUMINOS
#	print 'First trying Luminos Mounts....'
##         self.lum = controlMountSocket.mountControl(common.luminosPort, common.luminosNAxis)
#        self.lum = common.lum
##         self.lum = controlMount.mountControl(common.luminosPort, common.luminosBaud, common.luminosNAxis)
##         self.lum.configure()
#        time.sleep(.3) 
#        self.nluminos = self.lum.renumber()
#        print "self.nluminos = ", self.nluminos
        
#        if self.nluminos != 0:
            #try to index stage positions at each startup
#            file=self.path+self.lum_dir+'/'+self.lum_stage_file
#            try:
#                pos=open(file,'r')
#            except:
#                print file+' does not exist'
#                return -1
#            else:
#                print 'setting initial stage positions...'
#                 for ii in range(1,self.nluminos+1):
#                    for jj in range(1,4):
#                        line=pos.readline()
#                        li=int(line)
#                        self.lum.set_position(ii,jj,li)
#                pos.close()



	print 'Now trying CHAMP Offset Mounts....'
##         self.zab = controlMountSocket.mountControl(common.zaberPort, common.zaberNAxis)
        self.zab = common.zab
##         self.zab = controlMount.mountControl(common.zaberPort, common.zaberBaud, common.zaberNAxis)
##         self.zab.configure()
	time.sleep(.3)
        self.nzaber = self.zab.renumber()
        print "self.nzaber = ", self.nzaber

        #test variables: (can be deleted)
        self.xposition = 0
        self.yposition = 0
        self.zposition = 0	
        self.current_intensity = 0
		
        self.first_time = 1

        self.last_map_params = [0]*5
		
        self.x = na.arange(50000.,55100.,100.)
        self.y = na.arange(40000.,45100.,100.)
        x_mesh,y_mesh = meshgrid(self.x,self.y)
		
        #test intensity
        base = 10.
        amp = 50.
        sigma = 1000.
        mux = 52500.
        muy = 42500.
		
        self.intensity = base + amp*na.exp(-0.5*(((x_mesh-mux)**2)/(sigma**2) + \
                                              ((y_mesh-muy)**2)/(sigma**2)))
        self.intensity_fit = 0
        self.fit_params = 0
        self.map_error = True
        
        self.i = na.arange(0,256,1)
        self.j = na.arange(0,256,1)
        self.j_mesh,self.i_mesh = meshgrid(self.j,self.i)
        
        self.g = 0

        #x, y, z, intensity
        self.last_max = [0, 0, 0, 0]
        #x, y, sigma_x, sigma_y
        self.last_gauss = [0, 0, 0, 0]
        self.last_gauss_display = [0, 0, 0, 0]
        
        self.ij_range = [0, 256, 0, 256]
        print self.ij_range
        
        self.detector_configured = 0
        
        #create window
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        		
        #give it a name
        self.window.set_title("CHAMP Offset Pico Motor Control")
		
        #identify the destroy signal
        #self.window.connect("destroy", lambda x: gtk.main_quit())
        self.window.connect("destroy", self.destroy)
        
        #show the window
        self.window.show()				
		
        #create a notebook to sit in the main window
        self.notebook = gtk.Notebook()
        	
        #set tabs along the top
        self.notebook.set_tab_pos(gtk.POS_TOP)
        	
        #attach the notebook to the window
        self.window.add(self.notebook)

        #show the notebook
        self.notebook.show()
        
        #create little tables to sit within each notebook page
        #self.luminos_table = gtk.Table(8,8,False)
        #self.luminos_table.show()
        #luminos_label = gtk.Label('Luminos Control')
        #self.notebook.append_page(self.luminos_table,luminos_label)
		
        #self.mapping_table = gtk.Table(3,5,False)
        #self.mapping_table.show()
        #mapping_label = gtk.Label('Fiber Mapping')
        #self.notebook.append_page(self.mapping_table,mapping_label)

        #self.detector_table = gtk.Table(8,8,False)
        #self.detector_table.show()
        #detector_label = gtk.Label('Detector Control')
        #self.notebook.append_page(self.detector_table,detector_label)

        self.zaber_table = gtk.Table(6,6,False)
        self.zaber_table.show()
        self.zaber_label = gtk.Label('Pico Control')
        self.notebook.append_page(self.zaber_table,self.zaber_label)

        

        self.all_stage=[]
#        for ii in range(self.num_stages):
            #pdb.set_trace()
#            self.all_stage.append(mircMappingXchan.Stage_Info(1,ii+1,20,2))   #active, stage,side,spacing
		
	

        #############################################
        
        ######## Pick-off Mirror Delay Tab ##########
		
        ##z.configure()

	## JDM 2007Jul5 commented out the next line and replaced with a simple
	## defintions since the this program begins with a self.zab.renumber
        ##self.m = self.zab.renumber()
	self.m = self.nzaber
        print self.m 
        # set acceleration limits on aperture array and prism stages
        #self.zab.command(7,41,255)
        #self.zab.command(7,42,180)
        #self.zab.command(8,41,255)
        #self.zab.command(8,42,180)
        
        # set extension limits on all
        #self.zab.command(7,44,560000)
        #self.zab.command(8,44,560000)
        
        for i in range(6):
            self.zab.command(i+1,44,210000)

        #add command to limit actuators
            
        self.actuator = 1
				
        #joystick for moving mirror in and out
		
        self.zaber_joystick_table = gtk.Table(10,3,False)
        self.zaber_in_z_button = []
        self.zaber_out_z_button = []
        for i in range(6):
            self.zaber_in_z_button.append(self.create_arrow_button(gtk.ARROW_UP, gtk.SHADOW_IN))
            self.zaber_in_z_button[i].connect('clicked', self.zaber_move, 'IN', i+1)
            self.zaber_joystick_table.attach(self.zaber_in_z_button[i],i+1,i+2,0,1,\
                                             xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)
            self.zaber_out_z_button.append(self.create_arrow_button(gtk.ARROW_DOWN, gtk.SHADOW_IN))
            self.zaber_out_z_button[i].connect('clicked',self.zaber_move,'OUT', i+1)
            self.zaber_joystick_table.attach(self.zaber_out_z_button[i],i+1,i+2,2,3,\
                                             xoptions = False,yoptions = False,xpadding = 2, \
                                             ypadding = 2)

        #add labels to joystick buttons
	self.zaber_z_label = []
        lbl = ['IR1', 'IR2', 'IR3', 'IR4', 'IR5', 'IR6']
        for i in range(len(lbl)):
            self.zaber_z_label.append(gtk.Label(lbl[i]))
            self.zaber_z_label[i].show()
            self.zaber_joystick_table.attach(self.zaber_z_label[i],i+1,i+2,1,2,xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)
        
        self.zaber_jst_label = []
        #lbl = ['In', 'Out', 'OPD -', 'OPD +']
        lbl = ['OPD -', 'OPD +']
        #xy = [[9,10,0,1], [9,10,2,3], [0,1,0,1], [0,1,2,3]]
        xy = [[0,1,0,1], [0,1,2,3]]
        for i in range(len(lbl)):
            self.zaber_jst_label.append(gtk.Label(lbl[i]))
            self.zaber_jst_label[i].show()
            self.zaber_joystick_table.attach(self.zaber_jst_label[i],xy[i][0],xy[i][1],xy[i][2],\
                                             xy[i][3],xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)

        #add menus:
        self.zaber_menu_bar = []
        self.zaber_menu_name = []
        self.zaber_menu = []
        self.zaber_menu_item_home = []
        self.zaber_menu_item_good = []
        self.zaber_menu_item_other = []
        #act = [1, 6, 2, 5, 3, 4, 7, 8]
        act = [1, 2, 3, 4, 5, 6]
        for i in range(6):
            self.zaber_menu_bar.append(gtk.MenuBar())
            self.zaber_menu_bar[i].show()
            self.zaber_menu_name.append(gtk.MenuItem('Menu'))
            self.zaber_menu_name[i].show()
            self.zaber_menu.append(gtk.Menu())
            self.zaber_menu_item_home.append(gtk.MenuItem('Home'))
            self.zaber_menu_item_good.append(gtk.MenuItem('Good'))
            self.zaber_menu_item_other.append(gtk.MenuItem('Other'))
            self.zaber_menu_item_home[i].show()
            self.zaber_menu_item_good[i].show()
            self.zaber_menu_item_other[i].show()
            self.zaber_menu[i].append(self.zaber_menu_item_home[i])
            self.zaber_menu[i].append(self.zaber_menu_item_good[i])
            self.zaber_menu[i].append(self.zaber_menu_item_other[i])
            self.zaber_menu_item_home[i].connect("activate", self.zaber_home, act[i])
            self.zaber_menu_item_good[i].connect_object("activate", self.zaber_read_file, act[i], 'good.eal')
            self.zaber_menu_item_other[i].connect_object("activate", self.zaber_read_file, act[i], 'other.eal')
            self.zaber_menu_name[i].set_submenu(self.zaber_menu[i])
            self.zaber_menu_bar[i].append(self.zaber_menu_name[i])
            self.zaber_joystick_table.attach(self.zaber_menu_bar[i],\
                                             i+1,i+2,3,4, xoptions = False,\
                                             yoptions = False,xpadding = 2, ypadding = 2)
        self.zaber_joystick_table.show()
        
        #attach joystick table to notebook table
        self.zaber_table.attach(self.zaber_joystick_table,0,2,0,1,xoptions = False|True,\
                                yoptions = False|True)		
        
        #now add 'spin buttons' to select step size of zaber z motion
				
        #now for z, left button does 0.1 microns, right does 10
        self.zaber_z_adjustment = gtk.Adjustment(value=10., lower=0.1, upper=500.0, \
                                                 step_incr=0.1, page_incr=5, page_size=0)
        self.zaber_z_spin_button = gtk.SpinButton(adjustment=self.zaber_z_adjustment, \
                                                  climb_rate=0.0, digits=1)
        #constrain entered values to numbers (not letters)
        self.zaber_z_spin_button.set_numeric(numeric=True)
        #do not wrap from 100 microns to 0.
        self.zaber_z_spin_button.set_wrap(wrap=False)
        #if user enters a non-multiple of 0.1, the number is rounded off
        self.zaber_z_spin_button.set_snap_to_ticks(snap_to_ticks=True)
        #only change the value entered if it is a number within range
        self.zaber_z_spin_button.set_update_policy(gtk.UPDATE_IF_VALID)
        self.zaber_z_spin_button.show()
        
        #toggle switch to automatically view cross section
#        self.auto_cross_section = 0
#        self.auto_cross_section_check = gtk.CheckButton('View cross section after each move')
#        self.auto_cross_section_check.show()
#        self.auto_cross_section_check.connect("toggled",self.auto_cross_section_toggled)		
        #add these to the zaber_table in it's own table with lables
        self.zaber_spin_button_table = gtk.Table(3,3,False)
        #add spin_table to zaber table
        
        #add spin buttons and lables to spin_table
        self.zaber_spin_button_table.attach(self.zaber_z_spin_button,1,2,0,1,xpadding = 2, \
                                            ypadding = 2)
        
        self.zaber_z_spin_label = gtk.Label('Z step size:')
        self.zaber_z_spin_label.show()
        self.zaber_microns_label = gtk.Label('microns')
        self.zaber_microns_label.show()
        self.zaber_spin_button_table.attach(self.zaber_z_spin_label,0,1,0,1,xpadding = 2, \
                                            ypadding = 2)
        self.zaber_spin_button_table.attach(self.zaber_microns_label,2,3,0,1,xpadding = 2,\
                                            ypadding = 2)
        self.zaber_spin_button_table.show()
        
#        self.zaber_spin_button_table.attach(self.auto_cross_section_check,0,3,2,3,\
#                                            xoptions = False|True, yoptions = True|True,\
#                                            xpadding = 2, ypadding = 2)

        self.zaber_table.attach(self.zaber_spin_button_table,0,1,1,2,xoptions = False,\
                                yoptions = False,xpadding = 2, ypadding = 2)

        #combo box to choose a ealing actuator and enter position directly
        #self.zaber_renumber_button_label = gtk.Label('Renumber')
        #self.zaber_renumber_button = gtk.Button('Renumber')
        #self.zaber_renumber_button.connect("clicked",self.zaber_renumber_mount)
        #self.zaber_renumber_button_label.show()
        #self.zaber_renumber_button.show()
        
        self.zaber_home_all_button = gtk.Button('Home All')
        self.zaber_home_all_button.show()
        self.zaber_home_all_button.connect("clicked", self.zaber_home, 0)

        #self.zaber_restart_button = gtk.Button('Restart')
        #self.zaber_restart_button.show()
        #self.zaber_restart_button.connect("clicked",self.zaber_restart_mounts)
        
        self.zaber_save_position_button = gtk.Button('Save all positions to file')
        self.zaber_save_position_button.connect("clicked",self.zaber_save_pos)
        self.zaber_save_position_button.show()
		
        self.zaber_recall_position_button = gtk.Button('Recall all positions from file')
        self.zaber_recall_position_button.connect("clicked",self.zaber_recall_pos)
        self.zaber_recall_position_button.show()
        
        #create a table for buttons
        self.zaber_position_button_table = gtk.Table(1,6,False)
        self.zaber_position_button_table.show()
        
        self.zaber_position_button_table.attach(self.zaber_home_all_button,0,1,0,1,\
                                                xpadding = 2, ypadding = 2)
        #self.zaber_position_button_table.attach(self.zaber_renumber_button,1,2,0,1,\
        #                                        xpadding = 2, ypadding = 2)
        self.zaber_position_button_table.attach(self.zaber_save_position_button,2,3,0,1,\
                                                xpadding = 2, ypadding = 2)
        self.zaber_position_button_table.attach(self.zaber_recall_position_button,3,4,0,1,\
                                                xpadding = 2, ypadding = 2)
        #self.zaber_position_button_table.attach(self.zaber_restart_button,5,6,0,1,\
        #                                        xpadding = 2, ypadding = 2)		

        self.zaber_table.attach(self.zaber_position_button_table,0,2,2,3,\
                                xoptions = False|True,yoptions = False|True,\
                                xpadding = 2, ypadding = 2)

        #combo_box to choose ealing mount
        self.zaber_combo_box = gtk.combo_box_new_text()
        self.zaber_combo_box.show()
        self.zaber_combo_box.set_wrap_width(1)
        for i in range(6):#self.m):
            self.zaber_combo_box.append_text('CHAMP Offset IR%d' % (i+1))
		
        self.zaber_combo_box.set_active(self.actuator-1)
        self.zaber_combo_box.connect("changed",self.zaber_menu_changed)
        
        #create another table
        self.zaber_direct_move_table = gtk.Table(2,2,False)
        self.zaber_direct_move_table.show()

        #text box to hold position
        self.zaber_position_entry = gtk.Entry(max=6)
        self.zaber_position_entry.set_text(str(self.zab.absolute_position(self.actuator, 1)))
        self.zaber_position_entry.show()

        self.zaber_move_to_position_button = gtk.Button('Move to')
        self.zaber_move_to_position_button.connect("clicked",self.zaber_move_to_pos)
        self.zaber_move_to_position_button.show()
        
        self.zaber_refresh_position_button = gtk.Button('Refresh')
        self.zaber_refresh_position_button.connect("clicked",self.zaber_refresh_pos)
        self.zaber_refresh_position_button.show()
		
        self.zaber_direct_move_table.attach(self.zaber_combo_box,0,1,0,1,\
                                            xoptions = False|True,yoptions = False|True,\
                                            xpadding = 2, ypadding = 2)
        self.zaber_direct_move_table.attach(self.zaber_position_entry,0,1,1,2,\
                                            xoptions = False|True,yoptions = False|True,\
                                            xpadding = 2, ypadding = 2)
        self.zaber_direct_move_table.attach(self.zaber_move_to_position_button,1,2,0,1,\
                                            xpadding = 2, ypadding = 2)
        self.zaber_direct_move_table.attach(self.zaber_refresh_position_button,1,2,1,2,\
                                            xpadding = 2, ypadding = 2)

        self.zaber_table.attach(self.zaber_direct_move_table,1,2,1,2,xoptions = False|True,\
                                yoptions = False|True,xpadding = 2, ypadding = 2)

        #############################################
    
        ######### Extra Windows for Plots ###########
 
            
            

    #################  Zaber functions ###############

    #move zaber function
    def zaber_move(self,widget,direction,actuator):
        zz = long(self.zaber_z_spin_button.get_value())
        act = [{'IN':[1, -10*zz], 'OUT':[1,  10*zz]},
               {'IN':[6,  10*zz], 'OUT':[6, -10*zz]},
               {'IN':[2, -10*zz], 'OUT':[2,  10*zz]},
               {'IN':[5,  10*zz], 'OUT':[5, -10*zz]},
               {'IN':[3, -10*zz], 'OUT':[3,  10*zz]},
               {'IN':[4,  10*zz], 'OUT':[4, -10*zz]}]
#               {'IN':[7,  10*zz], 'OUT':[7, -10*zz]},
#               {'IN':[8,  10*zz], 'OUT':[8, -10*zz]}]
        self.zab.move_relative(act[actuator-1][direction][0], 1, act[actuator-1][direction][1])
        self.zaber_refresh_pos(0)
            
#        if (self.auto_cross_section):
#            self.view_cross_section(0)
	

    #functions for saving current position to a file
    def zaber_save_pos(self,widget):		
        self.zaber_save_filew = gtk.FileSelection('Save all positions to file')
        self.zaber_save_filew.connect("destroy",lambda w: self.zaber_save_filew.destroy())
        self.zaber_save_filew.ok_button.connect("clicked",self.zaber_file_save_action)
        self.zaber_save_filew.cancel_button.connect("clicked",lambda w: \
                                                    self.zaber_save_filew.destroy())
        self.zaber_save_filew.show()

    #function to actually do the filesaving
    def zaber_file_save_action(self,widget):
        self.zab.save_position(self.zaber_save_filew.get_filename(),self.m)
        print "save info to %s" % self.zaber_save_filew.get_filename()
        self.zaber_save_filew.destroy()

    #functions for recalling position from a file
    def zaber_recall_pos(self,widget):
        self.zaber_recall_filew = gtk.FileSelection('Recall all positions from file')
        self.zaber_recall_filew.connect("destroy",lambda w: self.zaber_recall_filew.destroy())
        self.zaber_recall_filew.ok_button.connect("clicked",self.zaber_file_recall_action)
        self.zaber_recall_filew.cancel_button.connect("clicked",\
                                                      lambda w: self.zaber_recall_filew.destroy())
        self.zaber_recall_filew.show()
                
    #function that actually recalls the file
    def zaber_file_recall_action(self,widget):
        self.zab.recall_position(self.zaber_recall_filew.get_filename(),self.m)
        print "recalled info from %s" % self.zaber_recall_filew.get_filename()
        self.zaber_recall_filew.destroy()		
			
    #def zaber_renumber_mount(self,widget):            
    #    print 'renumbering mounts '
    #    self.nzaber = self.zab.renumber()
    #	print "self.nzaber = ", self.nzaber
				
    #def zaber_restart_mounts(self,widget):
    #    self.zab.restart()
    #    self.zab.renumber_mount(0)		

    def zaber_home(self,widget,actuator):
        print 'actuator = ', actuator	
        self.zab.home(actuator, 1)
        self.zaber_refresh_pos(0)

    def zaber_read_file(self,actuator, filename):
        file = open(filename)
        text = file.read()
        positions = text.split("\n")
        self.zab.move_absolute(actuator, 1, long(positions[actuator-1]))
        self.zaber_refresh_pos(0)

#    def auto_cross_section_toggled(self,widget):
#        self.auto_cross_section = self.auto_cross_section_check.get_active()		

    #function for combo box to enter/see exact postion of ealing actuator:
    def zaber_menu_changed(self,combo_box):
#	act = [1, 6, 2, 5, 3, 4, 7, 8]
	act = [1, 2, 3, 4, 5, 6]
        self.actuator = act[combo_box.get_active()]
				
        #insert function to set text on position box
        self.zaber_refresh_pos(0)

    def zaber_move_to_pos(self,widget):
        self.zab.move_absolute(self.actuator, 1, long(self.zaber_position_entry.get_text()))
        
    def zaber_refresh_pos(self,widget):
        self.zaber_position_entry.set_text(str(self.zab.absolute_position(self.actuator, 1)))

    def main(self):        
        gtk.main()

def main():
#    pdb.set_trace()
    fib = fiber()
    fib.main()
   
print __name__
if __name__ == "__main__":
    main()
