#common.py:
import numarray as na

host  = '192.168.3.136'
port = 60000

status1 = 9
status2 = 9

# makes sure these faults match the defaults in ircam commands or there will be
# mismatch between values!
rows = 16
cols = 16
roff = 5   #7
coff = 20  #9

framesPerReset=21
numberOfFrames=42

dataready1 = 0
dataready2 = 0
myArray = na.zeros((rows, cols), type=na.Float32)
fluxArray = na.zeros((12,numberOfFrames), type=na.Float32)
psArray = na.zeros((rows/2, 1+cols/2), type=na.Float32)
fmArray = na.zeros((6,6), type=na.Float32)
#fm peaks: 4 quads (UR,UL,BL,BR), x,y,peak,Fraction in peak,total counts
fmPeaks = na.zeros((4,5), type=na.Float32)

fmFluxArray = na.zeros((100,4),type=na.Float32)

gdtInfo = na.zeros(7, type=na.UInt32)
delayLinesOffsets = na.zeros(6, type=na.Float64)
updatedOffsets = na.zeros(6, type=na.Float64)
weights = na.zeros(6, type=na.Float32)
opds  = na.zeros(6, type=na.Float32)
